#ifndef _REALTIME_DRIVER_H_
#define _REALTIME_DRIVER_H_

#include <ntddk.h>
//#include <wdm.h>
#include "IO_CTL.h"

//  True    
/*
typedef NTSTATUS (*NtDeleteFilePrcPointer) (
    IN PUNICODE_STRING FileName);
*/
typedef NTSTATUS
  (*NtOpenFile_PTR)(
    OUT PHANDLE  FileHandle,
    IN ACCESS_MASK  DesiredAccess,
    IN POBJECT_ATTRIBUTES  ObjectAttributes,
    OUT PIO_STATUS_BLOCK  IoStatusBlock,
    IN ULONG  ShareAccess,
    IN ULONG  OpenOptions
    );

//    
typedef struct _DRV_EXTENSION
{
  PDEVICE_OBJECT fdo;
  UNICODE_STRING SymLinkName;
  NtOpenFile_PTR OrigFunc; 
} DRV_EXTENSION, *PDRV_EXTENSION;


//     NT
typedef PVOID* PNTPROC;
typedef DWORD (ULONG);
typedef DWORD*	PDWORD;
typedef unsigned char (BYTE);
typedef BYTE* PBYTE;

typedef struct _SYSTEM_SERVICE_TABLE
{
    PNTPROC ServiceTable; 
    PDWORD  CounterTable; 
    ULONG   ServiceLimit; 
    PBYTE   ArgumentTable; 
}
SYSTEM_SERVICE_TABLE ,
* PSYSTEM_SERVICE_TABLE ,
* * PPSYSTEM_SERVICE_TABLE ;


typedef struct _SERVICE_DESCRIPTOR_TABLE {
   SYSTEM_SERVICE_TABLE ntoskrnl;  //SST  ntoskrnl.exe
   SYSTEM_SERVICE_TABLE win32k;    //SST  win32k.sys
   SYSTEM_SERVICE_TABLE unused1;   // 
   SYSTEM_SERVICE_TABLE unused2;   // 
}
SERVICE_DESCRIPTOR_TABLE ,
* PSERVICE_DESCRIPTOR_TABLE,
* * PPSERVICE_DESCRIPTOR_TABLE ;



//     SST 
#define NTCALL(_function) KeServiceDescriptorTable->ntoskrnl.ServiceTable[_function]

//   SDT
extern PSERVICE_DESCRIPTOR_TABLE KeServiceDescriptorTable;

//   NT
extern PUSHORT NtBuildNumber;


#endif